%define mpiimpl openmpi

Name: scotch
Version: 5.1.4
Release: alt1.M50.1
Summary: Package and libraries for sequential and parallel graph partitioning
License: CeCILL-C
Group: Sciences/Mathematics
Url: http://www.labri.fr/perso/pelegrin/scotch/
Packager: Eugeny A. Rostovtsev (REAL) <real at altlinux.org>

# svn checkout svn://scm.gforge.inria.fr/svn/scotch
Source: %{name}_%version.tar.gz
Source1: %{name}_%{version}_esmumps.tar.gz
Source2: Makefile.inc
Source3: Makefile.inc.esmumps

BuildRequires(pre): rpm-build-compat
BuildPreReq: gcc-fortran libgfortran-devel-static bison flex
BUildPreReq: libibverbs-devel-static libibumad-devel-static zlib-devel-static
BuildPreReq: glibc-devel-static %mpiimpl-devel-static

%description
Scotch is a software package and libraries for sequential and parallel graph
partitioning, static mapping, and sparse matrix block ordering, and sequential
mesh and hypergraph partitioning.

%package -n lib%name-devel
Summary: Static development files for Scotch
Group: Development/Other

%description -n lib%name-devel
Scotch is a software package and libraries for sequential and parallel graph
partitioning, static mapping, and sparse matrix block ordering, and sequential
mesh and hypergraph partitioning.

This package contains static development files for Scotch.

%package -n lib%name-devel-doc
Summary: Development documentation and example source code for Scotch
Group: Development/Other
BuildArch: noarch

%description -n lib%name-devel-doc
Scotch is a software package and libraries for sequential and parallel graph
partitioning, static mapping, and sparse matrix block ordering, and sequential
mesh and hypergraph partitioning.

This package contains development documentation and example source code
for Scotch.

%package data
Summary: grf files for Scotch
Group: Development/Other
BuildArch: noarch

%description data
Scotch is a software package and libraries for sequential and parallel graph
partitioning, static mapping, and sparse matrix block ordering, and sequential
mesh and hypergraph partitioning.

This package contains GRF and TGT files for Scotch.

%prep
%setup
tar -xzf %SOURCE1
install -m644 %SOURCE2 %SOURCE3 .

%build
pushd src
export MPIDIR=%_libexecdir/%mpiimpl
export PATH=$PATH:$MPIDIR/bin
export datarootdir=%_datadir
ln -s ../Makefile.inc .
%make_build
%make_build ptscotch
popd

pushd esmumps/src
ln -s ../../Makefile.inc.esmumps Makefile.inc
%make_build
popd

%install
pushd src
install -d %buildroot%_bindir
install -d %buildroot%_includedir
install -d %buildroot%_libdir
install -d %buildroot%_man1dir
install -d %buildroot%_docdir/%name
install -d %buildroot%_datadir/%name/grf
install -d %buildroot%_datadir/%name/tgt
%make_install_std
popd
install esmumps/src/esmumps/main_esmumps %buildroot%_bindir
install esmumps/lib/libesmumps.a %buildroot%_libdir

pushd doc
PATH=$PATH:%_libexecdir/%mpiimpl/bin
mpif77 -I../src/libscotch -c scotch_example.f -o scotch_example.o
mpif77 -o scotch_example scotch_example.o -Wl,-R%_libexecdir/%mpiimpl/lib \
	-L../lib -lscotchmetis -lscotcherrexit -lscotch -lscotcherr
install -m755 scotch_example %buildroot%_bindir
install -p -m644 ptscotch_user5.1.pdf scotch_user5.1.pdf scotch_example.f \
	%buildroot%_docdir/%name
popd

install -p -m644 grf/* %buildroot%_datadir/%name/grf
install -p -m644 esmumps/tgt/* %buildroot%_datadir/%name/tgt
install -p -m644 esmumps/src/esmumps/esmumps.h %buildroot%_includedir

%ifarch x86_64
install -m644 lib/* %buildroot%_libdir
%endif

%files
%doc LICENSE_en.txt doc/CeCILL-C_V1-en.txt
%_bindir/*
%_man1dir/*
%dir %_datadir/%name

%files -n lib%name-devel
%_libdir/*
%_includedir/*

%files -n lib%name-devel-doc
%_docdir/%name

%files data
%_datadir/%name/grf
%_datadir/%name/tgt

%changelog
* Wed May 13 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 5.1.4-alt1.M50.1
- Port for Branch 5.0

* Wed May 13 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 5.1.4-alt2
- Rebuild with gcc 4.4 and OpenMPI
- Disable static build for executables
- Fix for x86_64

* Fri Apr 24 2009 Eugeny A. Rostovtsev (REAL) <real at altlinux.org> 5.1.4-alt1
- Initial build for Sisyphus

